// java GetTimestampTest jdbc:postgresql:database user password 
import java.sql.*;
public class GetTimestampTest {
	public static void main(String[] args) {
		String pg71[] = {
			"select 'now'::date",
			"select 'now'::timestamp with time zone",
			"select 'now'::timestamp without time zone",
			// different time zone
			"select '2002-01-15 17:22:41+09'",
			"select '2002-01-15 17:22:41+00'",
			"select '2002-01-15 17:22:41.01+00:00'",
			"select '2002-01-15 17:22:41.50+00:01'",
			"select '2002-01-15 17:22:41.99-00:01'",
		};
		String pg72[] = {
			"select 'now'::timestamp(0) with time zone",
			"select 'now'::timestamp(0) without time zone",
			"select 'now'::timestamp(2) with time zone",
			"select 'now'::timestamp(2) without time zone",
			"select 'now'::timestamp(4) with time zone",
			"select 'now'::timestamp(4) without time zone",
			"select 'now'::timestamp(10) with time zone",
			"select 'now'::timestamp(10) without time zone",
			// limit test
			"select '2002-01-15 17:22:41.000001+00:01'",
			"select '2002-01-15 17:22:41.999999-00:01'",
			// over test
			"select '2002-01-15 17:22:41.0123456789012+00:10'",
			"select '2002-01-15 17:22:41.9876543210987-00:10'",
		};
		try {
			Class.forName("org.postgresql.Driver");
			Connection db = DriverManager.getConnection(args[0], args[1], args[2]);
			for (int i = 0; i < pg71.length; i++) {
				Statement st = db.createStatement();
				ResultSet rs = st.executeQuery(pg71[i]);
				rs.next();
				Timestamp ts = rs.getTimestamp(1);
				String str = rs.getString(1);
				System.out.println(pg71[i] + "\n  " + str + " --> " + ts);
				rs.close();
				st.close();
			}
			if (((org.postgresql.Connection) db).haveMinimumServerVersion("7.2")) {
				for (int i = 0; i < pg72.length; i++) {
					Statement st = db.createStatement();
					ResultSet rs = st.executeQuery(pg72[i]);
					rs.next();
					Timestamp ts = rs.getTimestamp(1);
					String str = rs.getString(1);
					System.out.println(pg72[i] + "\n  " + str + " --> " + ts);
					rs.close();
					st.close();
				}
			}
			db.close();
		} catch (Exception e) {
			System.out.println(e);
		}
	}
}

